import java.util.function.IntUnaryOperator;

public class RecursiveLambda {
	// Фибоначчийн тоог хун терелхтен вeрeдийн ахуй (from Mongolian Wikipedia)
	// initialising field lambda won't work
	// private IntUnaryOperator fib = n -> (n < 2) ? n :
	// 			fib.applyAsInt(n-1) + fib.applyAsInt(n-2);
	
	private IntUnaryOperator fib;
	
	public RecursiveLambda() {
		this.fib = n -> (n < 2) ? n : 
			this.fib.applyAsInt(n-1) + this.fib.applyAsInt(n-2);
	}
	
	// alternative to constructor is the instance initialising bloke
	// {{
	// 	this.fib = n -> (n < 2) ? n :
	// 		this.fib.applyAsInt(n-1) + this.fib.applyAsInt(n-2);
	// }}
							
	public static void main(String[] args) {
		// initialising local lambda won't work
		// IntUnaryOperator fib =
		// 		n -> (n < 2) ? n : fib.applyAsInt(n-1) + fib.applyAsInt(n-2);
		RecursiveLambda rl = new RecursiveLambda();
		for (int i = 1; i < 30; i++) {
			System.out.printf("%2d-th element of the sequence: %7d%n", i,
							rl.fib.applyAsInt(i));
		}
	}
}